#include "t_polygone.h"

t_polygone * t_polygone_init(int nb_points)
{
	int i; //Compteur de boucle 

	t_polygone *nouv_polygone;

	nouv_polygone = (t_polygone*)malloc(sizeof(t_polygone));
	nouv_polygone->nb_points = nb_points;
	nouv_polygone->points = (t_point**)malloc(nouv_polygone->nb_points * sizeof(t_point*));

	//On cre tous les points du polygone
	for (i = 0; i < nouv_polygone->nb_points; i++)
	{
		nouv_polygone->points[i] = t_point_init();
	}

	return nouv_polygone;
}

void t_polygone_destroy(t_polygone * polygone)
{
	int i; //Compteur de boucle

	//On commence par dtruire chacun des points du polygone
	for (i = 0; i < polygone->nb_points; i++) {
		t_point_destroy(polygone->points[i]);
	}

	//On libre la mmoire du polygone
	free(polygone);
}

int t_polygone_get_nb_points(const t_polygone * polygone)
{
	return polygone->nb_points;
}

void t_polygone_set_pointx(t_polygone * polygone, int num_point, double x, double y)
{
	t_point *p; //Stocke le point dont nous souhaitons dfinir les coordonnes

	//On vrifie d'abord que le point existe dans le polygone
	if (num_point >= polygone->nb_points) {
		return; //Rien  faire...
	}

	//Le point existe, on dfinit ses coordonnes
	p = polygone->points[num_point];

	p->x = x; 
	p->y = y;
}

void t_polygone_ajouter_point(t_polygone * polygone, double x, double y)
{
	//On doit d'abord tendre l'espace mmoire du tableau points
	polygone->points = (t_point**)realloc(polygone->points, (polygone->nb_points+1)*sizeof(t_point*) );

	//On cre le nouveau point
	polygone->points[polygone->nb_points] = t_point_init_coords(x, y);

	polygone->nb_points++;
}

double t_polygone_calculer_perimetre(t_polygone * polygone)
{
	double perimetre=0; //Variable utilise pour cumuler la distance calcule
	int i; //Compteur de boucle

	for (i = 0; i < polygone->nb_points-1; i++)
	{
		perimetre += t_point_calculer_distance(polygone->points[i], polygone->points[i + 1]);
	}

	perimetre+= t_point_calculer_distance(polygone->points[ polygone->nb_points -1], polygone->points[0]);

	return perimetre;
}
